
#property copyright "Copyright  2009, www.mtcoding.com, Dan Ostapyuk"
#property link      "http://www.mtcoding.com, dostapyuk@gmail.com"

extern datetime TimeToSetOrders = D'08.07.2011 16:30';
extern int WhatSecondToSetOrders = 0;
extern int SecondsToDeleteOrders = 120;
extern double LotSize = 0.1;
extern int GapOfOrders = 10;
extern int Slippage = 5;
extern int StopLoss = 10;
extern int TakeProfit = 50;
extern bool Use_TrailingStop = TRUE;
extern int TrailingStop = 25;
extern bool Use_Breakeven = TRUE;
extern int PipsProfitToBreakeven = 15;
extern bool OCO = TRUE;
extern string Programmer = "www.MtCoding.com";
extern color MainColor = DodgerBlue;
extern color SignalColor = Aqua;
extern color Activated = SpringGreen;
extern color Deactivated = Red;
int gi_156 = 10;
int gi_160 = 1643527899;
bool gi_164 = FALSE;

int init() {
 /* if (Digits == 3 || Digits == 5) {
      GapOfOrders = 10 * GapOfOrders;
      Slippage = 10 * Slippage;
      StopLoss = 10 * StopLoss;
      TakeProfit = 10 * TakeProfit;
      TrailingStop = 10 * TrailingStop;
      PipsProfitToBreakeven = 10 * PipsProfitToBreakeven;
   } */
   if (LotSize < MarketInfo(Symbol(), MODE_MINLOT)) {
      Alert("LotSize cannot be less than " + DoubleToStr(MarketInfo(Symbol(), MODE_MINLOT), 2));
      return (0);
   }
   if (LotSize > MarketInfo(Symbol(), MODE_MAXLOT)) {
      Alert("LotSize cannot be greater than " + DoubleToStr(MarketInfo(Symbol(), MODE_MAXLOT), 2));
      return (0);
   }
   if (GapOfOrders < MarketInfo(Symbol(), MODE_STOPLEVEL)) {
      Alert("GapOfOrders cannot be less than " + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL), 0));
      return (0);
   }
   if (StopLoss < MarketInfo(Symbol(), MODE_STOPLEVEL)) {
      Alert("StopLoss cannot be less than " + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL), 0));
      return (0);
   }
   if (TakeProfit < MarketInfo(Symbol(), MODE_STOPLEVEL)) {
      Alert("TakeProfit cannot be less than " + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL), 0));
      return (0);
   }
   DrawLabels();
   Comment("WAITING FOR TICK...www.MtCoding.com");
   return (0);
}

int deinit() {
   for (int li_0 = 0; li_0 <= 10; li_0++) {
      for (int li_4 = 0; li_4 <= ObjectsTotal() * 2; li_4++)
         if (StringSubstr(ObjectName(li_4), 0, 3) == "www") ObjectDelete(ObjectName(li_4));
   }
   return (0);
}

int start() {
   if (TimeCurrent() >= TimeToSetOrders && PrevOrderOpenTime() < TimeToSetOrders || PrevOrderOpenTime() == -1 && Seconds() >= WhatSecondToSetOrders) gi_164 = TRUE;
   if (gi_164) {
      if (TOOC() == 0) OrderSend(Symbol(), OP_BUYSTOP, LotSize, Ask + GapOfOrders * Point, Slippage, 0, 0, 0, gi_160, 0, Aqua);
      if (TOOC() == 1) OrderSend(Symbol(), OP_SELLSTOP, LotSize, Bid - GapOfOrders * Point, Slippage, 0, 0, 0, gi_160, 0, Red);
      if (TOOC() == 2) gi_164 = FALSE;
   }
   SetSLAndTP();
   OCO_Function();
   TrailingStop_Function();
   Breakeven_Function();
   ExpirationOfOrders();
   DrawLabels();
   ObjectCreate("my_logo", OBJ_LABEL, 0, 0, 0);
   ObjectSet("my_logo", OBJPROP_CORNER, 2);
   ObjectSet("my_logo", OBJPROP_XDISTANCE, 5);
   ObjectSet("my_logo", OBJPROP_YDISTANCE, 10);
   ObjectSetText("my_logo", "Programmer: support@mtcoding.com", 10, "Myrid Pro", RoyalBlue);
   return (0);
}

int TOOC() {
   int li_0;
   for (int li_4 = 0; li_4 < OrdersTotal(); li_4++) {
      if (OrderSelect(li_4, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol())
            if (OrderMagicNumber() == gi_160) li_0++;
      }
   }
   return (li_0);
}

int TOOCOpen() {
   int li_0;
   for (int li_4 = 0; li_4 < OrdersTotal(); li_4++) {
      if (OrderSelect(li_4, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160)
               if (OrderType() <= OP_SELL) li_0++;
         }
      }
   }
   return (li_0);
}

int TOOCPending() {
   int li_0;
   for (int li_4 = 0; li_4 < OrdersTotal(); li_4++) {
      if (OrderSelect(li_4, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160)
               if (OrderType() > OP_SELL) li_0++;
         }
      }
   }
   return (li_0);
}

void SetSLAndTP() {
   for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
      if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160) {
               if (OrderStopLoss() == 0.0) {
                  if (OrderType() == OP_BUYSTOP || OrderType() == OP_BUY) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - StopLoss * Point, OrderOpenPrice() + TakeProfit * Point, 0, Yellow);
                  if (OrderType() == OP_SELLSTOP || OrderType() == OP_SELL) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + StopLoss * Point + (Ask - Bid), OrderOpenPrice() - TakeProfit * Point + (Ask - Bid), 0, Yellow);
               }
            }
         }
      }
   }
}

void OCO_Function() {
   if (TOOCPending() == 1 && TOOCOpen() == 1) {
      for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
         if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == Symbol()) {
               if (OrderMagicNumber() == gi_160) {
                  if (OrderType() > OP_SELL)
                     if (OCO) OrderDelete(OrderTicket());
               }
            }
         }
      }
   }
}

void ExpirationOfOrders() {
   for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
      if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160) {
               if (OrderType() > OP_SELL)
                  if (TimeCurrent() >= OrderOpenTime() + SecondsToDeleteOrders) OrderDelete(OrderTicket());
            }
         }
      }
   }
}

void TrailingStop_Function() {
   for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
      if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160 && Use_TrailingStop) {
               if (OrderType() == OP_BUY)
                  if (OrderStopLoss() < Bid - TrailingStop * Point && Bid - OrderOpenPrice() >= TrailingStop * Point) OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * Point, OrderTakeProfit(), OrderExpiration(), Yellow);
               if (OrderType() == OP_SELL)
                  if (OrderStopLoss() > Ask + TrailingStop * Point && OrderOpenPrice() - Ask >= TrailingStop * Point) OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TrailingStop * Point, OrderTakeProfit(), OrderExpiration(), Yellow);
            }
         }
      }
   }
}

void Breakeven_Function() {
   for (int li_0 = 0; li_0 < OrdersTotal(); li_0++) {
      if (OrderSelect(li_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160 && Use_Breakeven) {
               if (OrderType() == OP_BUY)
                  if (Bid - OrderOpenPrice() >= PipsProfitToBreakeven * Point && OrderStopLoss() < OrderOpenPrice()) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), 0, Yellow);
               if (OrderType() == OP_SELL)
                  if (OrderOpenPrice() - Ask >= PipsProfitToBreakeven * Point && OrderStopLoss() > OrderOpenPrice()) OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - (Ask - Bid), OrderTakeProfit(), 0, Yellow);
            }
         }
      }
   }
}

int PrevOrderOpenTime() {
   int li_0 = -1;
   for (int li_4 = OrdersHistoryTotal() - 1; li_4 >= 0; li_4--) {
      if (OrderSelect(li_4, SELECT_BY_POS, MODE_HISTORY)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160) {
               li_0 = OrderOpenTime();
               break;
            }
         }
      }
   }
   return (li_0);
}

int CurrOrderOpenTime() {
   int li_0;
   for (int li_4 = 0; li_4 < OrdersTotal(); li_4++) {
      if (OrderSelect(li_4, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == gi_160) {
               li_0 = OrderOpenTime();
               break;
            }
         }
      }
   }
   return (li_0);
}

void DrawLabels() {
   string ls_0;
   string ls_40;
   ObjectCreate("www.mtcoding.com", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com", OBJPROP_YDISTANCE, 25);
   ObjectSetText("www.mtcoding.com", "Broker time:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com0.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com0.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com0.5", OBJPROP_XDISTANCE, 90);
   ObjectSet("www.mtcoding.com0.5", OBJPROP_YDISTANCE, 25);
   ObjectSetText("www.mtcoding.com0.5", "----" + TimeToStr(TimeCurrent(), TIME_DATE) + " " + TimeToStr(TimeCurrent(), TIME_SECONDS), gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com2", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com2", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com2", OBJPROP_YDISTANCE, 40);
   ObjectSetText("www.mtcoding.com2", "Time Orders Set:", gi_156, "Verdana", MainColor);
   if (WhatSecondToSetOrders < 10) ls_0 = "0";
   ObjectCreate("www.mtcoding.com2.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com2.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com2.5", OBJPROP_XDISTANCE, 118);
   ObjectSet("www.mtcoding.com2.5", OBJPROP_YDISTANCE, 40);
   ObjectSetText("www.mtcoding.com2.5", TimeToStr(TimeToSetOrders) + ":" + ls_0 + WhatSecondToSetOrders, gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com3", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com3", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com3", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com3", OBJPROP_YDISTANCE, 55);
   ObjectSetText("www.mtcoding.com3", "Seconds left to delete pending orders:", gi_156, "Verdana", MainColor);
   double ld_8 = CurrOrderOpenTime() + SecondsToDeleteOrders - TimeCurrent();
   string ls_16 = DoubleToStr(ld_8, 0) + " sec.(about " + DoubleToStr(ld_8 / 60.0, 0) + " min.)";
   if (TOOCPending() == 0) ls_16 = "No pending orders open(" + SecondsToDeleteOrders + ")";
   ObjectCreate("www.mtcoding.com3.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com3.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com3.5", OBJPROP_XDISTANCE, 260);
   ObjectSet("www.mtcoding.com3.5", OBJPROP_YDISTANCE, 55);
   if (TOOCPending() > 0) ObjectSetText("www.mtcoding.com3.5", ls_16, gi_156, "Verdana", Activated);
   if (TOOCPending() == 0) ObjectSetText("www.mtcoding.com3.5", ls_16, gi_156, "Verdana", Deactivated);
   ObjectCreate("www.mtcoding.com4", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com4", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com4", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com4", OBJPROP_YDISTANCE, 70);
   ObjectSetText("www.mtcoding.com4", "LotSize:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com4.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com4.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com4.5", OBJPROP_XDISTANCE, 57);
   ObjectSet("www.mtcoding.com4.5", OBJPROP_YDISTANCE, 70);
   ObjectSetText("www.mtcoding.com4.5", DoubleToStr(LotSize, 2), gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com5", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com5", OBJPROP_YDISTANCE, 85);
   ObjectSetText("www.mtcoding.com5", "GapOfOrders:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com5.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com5.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com5.5", OBJPROP_XDISTANCE, 92);
   ObjectSet("www.mtcoding.com5.5", OBJPROP_YDISTANCE, 85);
   ObjectSetText("www.mtcoding.com5.5", "" + GapOfOrders, gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com6", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com6", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com6", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com6", OBJPROP_YDISTANCE, 100);
   ObjectSetText("www.mtcoding.com6", "Slippage:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com6.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com6.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com6.5", OBJPROP_XDISTANCE, 65);
   ObjectSet("www.mtcoding.com6.5", OBJPROP_YDISTANCE, 100);
   ObjectSetText("www.mtcoding.com6.5", "" + Slippage, gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com7", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com7", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com7", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com7", OBJPROP_YDISTANCE, 115);
   ObjectSetText("www.mtcoding.com7", "StopLoss:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com7.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com7.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com7.5", OBJPROP_XDISTANCE, 70);
   ObjectSet("www.mtcoding.com7.5", OBJPROP_YDISTANCE, 115);
   ObjectSetText("www.mtcoding.com7.5", "" + StopLoss, gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com8", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com8", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com8", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com8", OBJPROP_YDISTANCE, 130);
   ObjectSetText("www.mtcoding.com8", "TakeProfit:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com8.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com8.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com8.5", OBJPROP_XDISTANCE, 77);
   ObjectSet("www.mtcoding.com8.5", OBJPROP_YDISTANCE, 130);
   ObjectSetText("www.mtcoding.com8.5", "" + TakeProfit, gi_156, "Verdana", SignalColor);
   ObjectCreate("www.mtcoding.com9", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com9", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com9", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com9", OBJPROP_YDISTANCE, 145);
   ObjectSetText("www.mtcoding.com9", "TrailingStop:", gi_156, "Verdana", MainColor);
   string ls_24 = "Deactivated(" + TrailingStop + ")";
   if (Use_TrailingStop) ls_24 = DoubleToStr(TrailingStop, 0);
   ObjectCreate("www.mtcoding.com9.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com9.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com9.5", OBJPROP_XDISTANCE, 88);
   ObjectSet("www.mtcoding.com9.5", OBJPROP_YDISTANCE, 145);
   if (Use_TrailingStop) ObjectSetText("www.mtcoding.com9.5", "Activated(" + ls_24 + ")", gi_156, "Verdana", Activated);
   if (!Use_TrailingStop) ObjectSetText("www.mtcoding.com9.5", "" + ls_24, gi_156, "Verdana", Deactivated);
   ObjectCreate("www.mtcoding.com10", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com10", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com10", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com10", OBJPROP_YDISTANCE, 160);
   ObjectSetText("www.mtcoding.com10", "Breakeven:", gi_156, "Verdana", MainColor);
   string ls_32 = "Deactivated(" + PipsProfitToBreakeven + ")";
   if (Use_Breakeven) ls_32 = DoubleToStr(PipsProfitToBreakeven, 0);
   ObjectCreate("www.mtcoding.com10.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com10.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com10.5", OBJPROP_XDISTANCE, 78);
   ObjectSet("www.mtcoding.com10.5", OBJPROP_YDISTANCE, 160);
   if (!Use_Breakeven) ObjectSetText("www.mtcoding.com10.5", "" + ls_32, gi_156, "Verdana", Deactivated);
   if (Use_Breakeven) ObjectSetText("www.mtcoding.com10.5", "Activated(" + ls_32 + ")", gi_156, "Verdana", Activated);
   ObjectCreate("www.mtcoding.com11", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com11", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com11", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com11", OBJPROP_YDISTANCE, 175);
   ObjectSetText("www.mtcoding.com11", "OCO:", gi_156, "Verdana", MainColor);
   if (OCO) ls_40 = "true";
   if (!OCO) ls_40 = "false";
   ObjectCreate("www.mtcoding.com11.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com11.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com11.5", OBJPROP_XDISTANCE, 38);
   ObjectSet("www.mtcoding.com11.5", OBJPROP_YDISTANCE, 175);
   if (OCO) ObjectSetText("www.mtcoding.com11.5", "" + ls_40, gi_156, "Verdana", Activated);
   if (!OCO) ObjectSetText("www.mtcoding.com11.5", "" + ls_40, gi_156, "Verdana", Deactivated);
   ObjectCreate("www.mtcoding.com12", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com12", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com12", OBJPROP_XDISTANCE, 3);
   ObjectSet("www.mtcoding.com12", OBJPROP_YDISTANCE, 190);
   ObjectSetText("www.mtcoding.com12", "Searching TimeToSetOrders:", gi_156, "Verdana", MainColor);
   ObjectCreate("www.mtcoding.com12.5", OBJ_LABEL, 0, 0, 0);
   ObjectSet("www.mtcoding.com12.5", OBJPROP_CORNER, 0);
   ObjectSet("www.mtcoding.com12.5", OBJPROP_XDISTANCE, 195);
   ObjectSet("www.mtcoding.com12.5", OBJPROP_YDISTANCE, 190);
   if (TimeCurrent() < TimeToSetOrders) ObjectSetText("www.mtcoding.com12.5", "Active", gi_156, "Verdana", Activated);
   if (TimeCurrent() >= TimeToSetOrders) ObjectSetText("www.mtcoding.com12.5", "Not Active; set of orders done.", gi_156, "Verdana", Deactivated);
}